%errorA = ForceRequiredAddOn("Weapon_Homing_Rocket");
%errorB = ForceRequiredAddOn("Support_HeightControl");
%errorC = ForceRequiredAddOn("Weapon_Gun");


if(%errorA == $Error::AddOn_Disabled)
   JeepVehicle.uiName = "";
if(%errorB == $Error::AddOn_Disabled)
   rocketLauncherItem.uiName = "";
if(%errorC == $Error::AddOn_Disabled)
   gunItem.uiName = "";
   
if(%errorA == $Error::AddOn_NotFound)
   error("ERROR: Vehicle_Apache - required add-on Weapon_Homing_Rocket not found");
else if(%errorB == $Error::AddOn_NotFound)
   error("ERROR: Vehicle_Apache - required add-on Support_HeightControl not found");
else if(%errorC == $Error::AddOn_NotFound)
   error("ERROR: Vehicle_Apache - required add-on Weapon_Gun not found");
else
exec("./vehicle_apache.cs");

package ApacheASOCPack
{
	function armor::onTrigger(%db,%obj,%slot,%val)
	{
		if(%obj.getClassName()$="Player")
		{
			if(%slot==0)
			{
				if(%val)
				{
					if($Sim::Time<%obj.client.ASOC_LastFireTime)
					{
						return;
					}
				}
				%obj.ASOC_Shoot(%slot,%val);
			}
		} else if(%obj.getClassName()$="AIPlayer")
		{
			if(%slot==2)
			{
				if(%val)
				{
					if($Sim::Time<%obj.ASOC_LastFireTime2)
					{
						return;
					}
				}
				%obj.ASOC_Shoot2(%slot,%val);
			}
		}
		return Parent::onTrigger(%db,%obj,%slot,%val);
	}
	function Armor::onMount(%db,%player,%target,%slot)
	{
		Parent::onMount(%db,%player,%target,%slot);
		if(isObject(%player.client) && isObject(%target) && %target.getDatablock() == ApacheVehicle.getID() && %slot == 0)
		{
			commandToClient(%player.client,'bottomprint',"<just:right><font:Impact:24pt>\c3Missile Pods <font:Impact:34pt>\c6" @ %target.missiles SPC "/" SPC %target.getDatablock().maxAmmo,0,1);
		}
	}
	function Armor::onUnMount(%db,%player,%target,%slot)
	{
		Parent::onUnMount(%db,%player,%target,%slot);
		if(isObject(%player.client) && isObject(%target) && %target.getDatablock() == ApacheVehicle.getID() && %slot == 0)
		{
			commandToClient(%player.client,'bottomprint',"",0,1);
		}
	}
};
ActivatePackage(ApacheASOCPack);

function repeatedVectorAddwithScale(%vecs)
{
	%vec="0 0 0";
	%cnt=getFieldCount(%vecs);
	for(%i=0;%i<%cnt;%i++)
	{
		%fld=getField(%vecs,%i);
		%tvec=getWords(%fld,0,3);
		%scale=getWord(%fld,3);
		%svec=vectorScale(%tvec,%scale);
		%vec=vectorAdd(%vec,%svec);
	}
	return %vec;
}

function SimObject::getLeftVector(%obj)
{
	return vectorCross(%obj.getEyeVector(),%obj.getUpVector());
}

function SimObject::getRightVector(%obj)
{
	return vectorScale(%obj.getLeftVector(%obj),-1);
}

function Player::ASOC_Shoot(%obj,%slot,%val)
{
	if(!%val) {cancel(%obj.ASOC_reshoot);return;}
	
	%mnt= %obj.getObjectMount();
	if(!isObject(%mnt))
	{
		return;
	}

	%data= %mnt.getDatablock();
	
	%mountObj= %mnt.getMountNodeObject(%data.AshootOnClick_RequiredSlot);
	if(%mountObj!$=%Obj) {return;}
	
	if(%data.AshootOnClick)
	{
		//Checks OK, shoot it all.
		if(%mnt.getDatablock() == ApacheVehicle.getID())
		{
			%ammo = mClampF(%mnt.missiles,0,%data.maxAmmo);
			if(%ammo <= 0)
			{
				serverPlay3d(%data.emptySound,%obj.getPosition());
				if(isObject(%obj.client))
				{
					commandToClient(%obj.client,'bottomPrint',"<just:right><font:Impact:24pt>\c3Missile Pods <font:Impact:34pt>\c6" @ %mnt.missiles SPC "/" SPC %data.maxAmmo,0,1);
				}
				if(%data.AshootOnClick_Hold)
				{
					//Delay according to datablocks.
					%obj.ASOC_reshoot= %obj.schedule(%data.AshootOnClick_ReshootDelay,ASOC_Shoot,%slot,%val);
				}
				return;
			} else {
				%mnt.missiles = mClampF(%mnt.missiles - 1,0,%data.maxAmmo - 1);
				cancel(%mnt.ammoRegenTick);
				%mnt.ammoRegenTick = %data.schedule(%data.ammoRegenTime,"ammoRegenTick",%mnt);
				if(isObject(%obj.client))
				{
					commandToClient(%obj.client,'bottomPrint',"<just:right><font:Impact:24pt>\c3Missile Pods <font:Impact:34pt>\c6" @ %mnt.missiles SPC "/" SPC %data.maxAmmo,0,1);
				}
			}
		}
		%cnt=%data.AshootOnClick_ProjectileCount;
		for(%i=0;%i<%cnt;%i++)
		{
			%pos= %mnt.getPosition();
			%PVec= %data.AshootOnClick_Position[%i];
			%VVec= %data.AshootOnClick_Velocity[%i];
			%iPos= repeatedVectorAddwithScale(
			%mnt.getEyeVector() SPC getWord(%PVec,0) TAB
			%mnt.getLeftVector() SPC getWord(%PVec,1) TAB
			%mnt.getUpVector() SPC getWord(%PVec,2)
			);
			%iVel= repeatedVectorAddwithScale(
			%mnt.getEyeVector() SPC getWord(%VVec,0) TAB
			%mnt.getLeftVector() SPC getWord(%VVec,1) TAB
			%mnt.getUpVector() SPC getWord(%VVec,2)
			);
			if(%mnt.getDatablock() == ApacheTurretPlayer.getID())
			{
				%iVel = setWord(%iVel,2,mClampF(getWord(%iVel,2),-1000,0));
				if(vectorLen(%iVel) < 10)
				{
					if(%data.AshootOnClick_Hold)
					{
						//Delay according to datablocks.
						%obj.ASOC_reshoot= %obj.schedule(%data.AshootOnClick_ReshootDelay,ASOC_Shoot,%slot,%val);
					}
					return;
				}
				%iVel = applySpread(%iVel,ApacheTurretPlayer.spread);
			}
			%scale=%data.AshootOnClick_Scale[%i];
			if(%scale$="") {%scale="1 1 1";}
			%p= new Projectile()
			{
				dataBlock= %data.AshootOnClick_Projectile[%i];
				initialPosition= vectorAdd(%pos,%iPos);
				initialVelocity= %iVel;
				sourceObject= %obj;
				client= %obj.client;
				sourceSlot= %slot;
				scale= %scale;
			};missionCleanup.add(%p);
		}
		serverPlay3d(%data.AshootOnClick_Sound,%pos);
		
		//If hold, schedule.
		if(%data.AshootOnClick_Hold)
		{
			//Delay according to datablocks.
			%obj.ASOC_reshoot= %obj.schedule(%data.AshootOnClick_ReshootDelay,ASOC_Shoot,%slot,%val);
		}
		%obj.client.ASOC_LastFireTime=$Sim::Time+%data.AshootOnClick_ShootDelay/1000;
	}
}

function AIPlayer::ASOC_Shoot2(%obj,%slot,%val)
{
	if(!%val) {cancel(%obj.ASOC_reshoot2);return;}

	%player = %obj.getMountedObject(0);

	%data= %obj.getDatablock();
	
	%mountObj= %obj.getMountNodeObject(%data.AshootOnClick_RequiredSlot2);
	//if(%mountObj!$=%Obj) {return;}
	
	if(%data.AshootOnClick2)
	{
		//Checks OK, shoot it all.
		if(%mnt.getDatablock() == ApacheVehicle.getID())
		{
			%ammo = mClampF(%mnt.missiles,0,%data.maxAmmo);
			if(%ammo <= 0)
			{
				serverPlay3d(%data.emptySound,%obj.getPosition());
				if(%data.AshootOnClick_Hold2)
				{
					//Delay according to datablocks.
					%obj.ASOC_reshoot2= %obj.schedule(%data.AshootOnClick_ReshootDelay2,ASOC_Shoot2,%slot,%val);
				}
				return;
			} else {
				%mnt.missiles = mClampF(%mnt.missiles - 1,0,%data.maxAmmo - 1);
				cancel(%mnt.ammoRegenTick);
				%mnt.ammoRegenTick = %data.schedule(%data.ammoRegenTime,"ammoRegenTick",%mnt);
			}
		}
		%cnt=%data.AshootOnClick_ProjectileCount2;
		for(%i=0;%i<%cnt;%i++)
		{
			%pos= %obj.getPosition();
			%PVec= %data.AshootOnClick_Position2[%i];
			%VVec= %data.AshootOnClick_Velocity2[%i];
			%iPos= repeatedVectorAddwithScale(
			%obj.getEyeVector() SPC getWord(%PVec,0) TAB
			%obj.getLeftVector() SPC getWord(%PVec,1) TAB
			%obj.getUpVector() SPC getWord(%PVec,2)
			);
			%iVel= repeatedVectorAddwithScale(
			%obj.getEyeVector() SPC getWord(%VVec,0) TAB
			%obj.getLeftVector() SPC getWord(%VVec,1) TAB
			%obj.getUpVector() SPC getWord(%VVec,2)
			);
			if(%mnt.getDatablock() == ApacheTurretPlayer.getID())
			{
				%iVel = setWord(%iVel,2,mClampF(getWord(%iVel,2),-1000,0));
				if(vectorLen(%iVel) < 10)
				{
					if(%data.AshootOnClick_Hold2)
					{
						//Delay according to datablocks.
						%obj.ASOC_reshoot2= %obj.schedule(%data.AshootOnClick_ReshootDelay2,ASOC_Shoot2,%slot,%val);
					}
					return;
				}
				%iVel = applySpread(%iVel,ApacheTurretPlayer.spread);
			}
			%scale=%data.AshootOnClick_Scale2[%i];
			if(%scale$="") {%scale="1 1 1";}
			%p= new Projectile()
			{
				dataBlock= %data.AshootOnClick_Projectile2[%i];
				initialPosition= vectorAdd(%pos,%iPos);
				initialVelocity= %iVel;
				sourceObject= %player;
				client= %player.client;
				sourceSlot= %slot;
				scale= %scale;
			};missionCleanup.add(%p);
		}
		serverPlay3d(%data.AshootOnClick_Sound2,%pos);
		
		//If hold, schedule.
		if(%data.AshootOnClick_Hold2)
		{
			//Delay according to datablocks.
			%obj.ASOC_reshoot2= %obj.schedule(%data.AshootOnClick_ReshootDelay2,ASOC_Shoot2,%slot,%val);
		}
		%obj.ASOC_LastFireTime2=$Sim::Time+%data.AshootOnClick_ShootDelay2/1000;
	}
}

function ApacheVehicle::ammoRegenTick(%data,%this)
{
	cancel(%this.ammoRegenTick);
	if(!isObject(%this))
		return;

	%this.missiles = mClampF(%this.missiles + 1,0,%data.maxAmmo);
	%o = %this.getMountedObject(0);
	%this.getMountedObject(1).isCloaked = 1;
	
	if(isObject(%o.client))
	{
		commandToClient(%o.client,'bottomPrint',"<just:right><font:Impact:24pt>\c3Missile Pods <font:Impact:34pt>\c6" @ %this.missiles SPC "/" SPC %data.maxAmmo,0,1);
	}
	serverPlay3d(%data.reloadSound,%this.getPosition());
	if(%this.missiles < %data.maxAmmo)
	{
		%this.ammoRegenTick = %data.schedule(%data.ammoRegenTime,"ammoRegenTick",%this);
	}
}
function applySpread(%vec,%spread)
{
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	return MatrixMulVector(%mat, %vec);
}